/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gnome.h>

#include "support.h"
#include "debug.h"

GtkWidget      *
lookup_widget(GtkWidget * widget, const gchar * widget_name)
{
    GtkWidget      *parent,
                   *found_widget;

    for (;;) {
	if (GTK_IS_MENU(widget))
	    parent = gtk_menu_get_attach_widget(GTK_MENU(widget));
	else
	    parent = widget->parent;
	if (!parent)
	    parent =
		(GtkWidget *) g_object_get_data(G_OBJECT(widget),
						"GladeParentKey");
	if (parent == NULL)
	    break;
	widget = parent;
    }

    found_widget = (GtkWidget *) g_object_get_data(G_OBJECT(widget),
						   widget_name);
    if (!found_widget)
	g_warning(_("Widget not found: %s"), widget_name);
    return found_widget;
}

/*
 * This is an internally used function to create pixmaps. 
 */
GtkWidget      *
create_pixmap(GtkWidget * widget, const gchar * filename)
{
    GtkWidget      *pixmap;
    gchar          *pathname;

    if (!filename || !filename[0])
	return gtk_image_new();

    pathname =
	gnome_program_locate_file(NULL, GNOME_FILE_DOMAIN_APP_PIXMAP,
				  filename, TRUE, NULL);
    if (!pathname) {
	g_warning(_("Couldn't find pixmap file: %s"), filename);
	return gtk_image_new();
    }

    pixmap = gtk_image_new_from_file(pathname);
    g_free(pathname);
    return pixmap;
}

/*
 * This is an internally used function to create pixmaps. 
 */

/*
 * Edit for me for this project
 */
GdkPixbuf      *
create_pixbuf(const gchar * filename)
{
    gchar          *syst_icon = NULL,
					*user_icon = NULL,
					*icon = NULL;
    GdkPixbuf      *pixbuf = NULL;
    GError         *error = NULL;

    if (!filename || !filename[0])
	return NULL;

    user_icon = g_strdup_printf("%s/%s", PACKAGE_DATA_DIR "/pixmaps/" PACKAGE "/user", filename);
	syst_icon = g_strdup_printf("%s/%s", PACKAGE_DATA_DIR "/pixmaps/" PACKAGE "/system", filename);
	
	if (g_file_test(user_icon, G_FILE_TEST_EXISTS)) {
		icon = g_strdup (user_icon);
	}
	else {
		icon = g_strdup (syst_icon);
	}
	
    pixbuf = gdk_pixbuf_new_from_file(icon, &error);
	if (error) {
		vazaar_gui_show_dialog (NULL, GTK_STOCK_DIALOG_ERROR, error->code, error->message, NULL);
		g_error_free(error);
	}
    if (!pixbuf) {
		if (DEBUG) {
			g_message("Failed to load pixbuf file: %s: %s\n", icon, error->message);
		}
		
    }
	
    g_free(icon); g_free(user_icon); g_free(syst_icon);

    return pixbuf;
}

/*
 * This is used to set ATK action descriptions. 
 */
void
glade_set_atk_action_description(AtkAction * action,
				 const gchar * action_name,
				 const gchar * description)
{
    gint            n_actions,
                    i;

    n_actions = atk_action_get_n_actions(action);
    for (i = 0; i < n_actions; i++) {
		if (!strcmp(atk_action_get_name(action, i), action_name))
			atk_action_set_description(action, i, description);
		}
}
